; IN-MEMPTR v0.1
; Copyright (C) 2021 Ped7g and ZjoyKiLer
; Released as Public Domain

	device zxspectrum48, $7FFE
	org $7FFF

start:
	call $0DAF        ; CLS
	ld   a,2
	call $1601        ; ROM channel# open
	ld   hl,0         ; NULL pointer
	ld   a,15         ; A = 0b1111
	in   a,($FF)      ; MEMPTR = ((0b1111 << 8) | 0b11111111) + 1
	bit  0,(hl)       ; XF = MEMPTRH.3; YF = MEMPTRH.5
	push af           ; E.3 = XF
	pop  de           ;
	bit  3,e          ; Check if MEMPTRH was affected by carry
	ld   hl,msg_true  ; MTMPTRH is affected by carry
	jr   z,print
	ld   hl,msg_false ; MEMPTR is not affected by carry

print:
	ld   a,(hl)
	or   a
	jr   z,$          ; Infinite loop on terminator byte (test finished)
	rst  $10
	inc  hl
	jr   print

msg_true:
	BYTE "in a,(n): memptr = ((a<<8)|n)+1",  0

msg_false:
	BYTE "in a,(n): memptr = unknown",  0

	MACRO MakeTape tape_file, prog_name, start_add, code_len, call_add

CODE	  = $AF
USR	  = $C0
LOAD	  = $EF
CLEAR	  = $FD
RANDOMIZE = $F9

	org	$5C00
baszac:	db	0,1    ; Line number
	dw	linlen ; Line length
linzac:
	db	CLEAR,'8',$0E,0,0
	dw	start_add-1
	db	0,':'
	db	LOAD,'"'
codnam:	ds	10,32
	org	codnam
	db	prog_name
	org	codnam+10
	db	'"',CODE,':'
	db	RANDOMIZE,USR,'8',$0E,0,0
	dw	call_add
	db	0,$0D

linlen = $-linzac
baslen = $-baszac

	EMPTYTAP tape_file
	SAVETAP  tape_file,BASIC,prog_name,baszac,baslen,1
	SAVETAP  tape_file,CODE,prog_name,start_add,code_len,start_add
	ENDM

size = $ - start

	MakeTape "IN-MEMPTR.tap", "IN-MEMPTR", start, size, start

; IN-MEMPTR.asm EOF
